#include <stdio.h>
#include <stdlib.h>

#include "avl.h"

int
compare_longs (void * a, void * b)
{
  long la, lb;
  la = (long) a;
  lb = (long) b;
  
  if (la < lb) {
    return -1;
  } else if (la > lb) {
    return +1;
  } else {
    return 0;
  }
}

int
long_printer (char * buffer, void * key)
{
  return sprintf (buffer, "%ld", (long) key);
}

int
null_key_free (void * key) {
  return 0;
}

int
main (int argc, char ** argv)
{
  avl_tree * tree;

  tree = new_avl_tree();

  insert_by_key (tree, (void *) 50, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 45, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 15, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 10, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 75, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 55, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 70, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 80, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 60, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 32, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 20, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 40, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 25, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 22, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 31, compare_longs); print_tree (tree, long_printer); verify (tree);
  insert_by_key (tree, (void *) 30, compare_longs); print_tree (tree, long_printer); verify (tree);
  while (tree->length) {
    int num = 0;

    fscanf (stdin, "%d", &num);
    fprintf (stdout, "deleting %d\n", num);
    remove_by_key (tree, (void *) num, compare_longs, null_key_free);
    print_tree (tree, long_printer);
    verify (tree);
  }
  return 0;
}
